require '_h2ph_pre.ph';

unless(defined(&_ASM_PGTABLE_H)) {
    eval 'sub _ASM_PGTABLE_H () {1;}' unless defined(&_ASM_PGTABLE_H);
    require 'asm/addrspace.ph';
    require 'asm/page.ph';
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
	require 'linux/linkage.ph';
	require 'asm/cachectl.ph';
	require 'linux/config.ph';
	eval 'sub flush_dcache_page {
	    local($page) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_dcache_page);
	eval 'sub flush_cache_all () {
	    eval q( &_flush_cache_all());
	}' unless defined(&flush_cache_all);
	eval 'sub flush_cache_mm {
	    local($mm) = @_;
    	    eval q( &_flush_cache_mm($mm));
	}' unless defined(&flush_cache_mm);
	eval 'sub flush_cache_range {
	    local($mm,$start,$end) = @_;
    	    eval q( &_flush_cache_range($mm,$start,$end));
	}' unless defined(&flush_cache_range);
	eval 'sub flush_cache_page {
	    local($vma,$page) = @_;
    	    eval q( &_flush_cache_page($vma, $page));
	}' unless defined(&flush_cache_page);
	eval 'sub flush_cache_sigtramp {
	    local($addr) = @_;
    	    eval q( &_flush_cache_sigtramp($addr));
	}' unless defined(&flush_cache_sigtramp);
	eval 'sub flush_page_to_ram {
	    local($page) = @_;
    	    eval q( &_flush_page_to_ram($page));
	}' unless defined(&flush_page_to_ram);
	eval 'sub flush_icache_range {
	    local($start, $end) = @_;
    	    eval q( &_flush_icache_range($start,$end));
	}' unless defined(&flush_icache_range);
	eval 'sub flush_icache_page {
	    local($vma, $page, $addr) = @_;
    	    eval q( &_flush_icache_page($vma, $page, $addr));
	}' unless defined(&flush_icache_page);
    }
    eval 'sub PMD_SHIFT () {22;}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SHIFT () {22;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub PTRS_PER_PTE () {1024;}' unless defined(&PTRS_PER_PTE);
    eval 'sub PTRS_PER_PMD () {1;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PGD () {1024;}' unless defined(&PTRS_PER_PGD);
    eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE/ &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
    eval 'sub VMALLOC_START () { &KSEG2;}' unless defined(&VMALLOC_START);
    eval 'sub VMALLOC_VMADDR {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&VMALLOC_VMADDR);
    eval 'sub VMALLOC_END () { &KSEG3;}' unless defined(&VMALLOC_END);
    eval 'sub _PAGE_PRESENT () {(1<<0);}' unless defined(&_PAGE_PRESENT);
    eval 'sub _PAGE_READ () {(1<<1);}' unless defined(&_PAGE_READ);
    eval 'sub _PAGE_WRITE () {(1<<2);}' unless defined(&_PAGE_WRITE);
    eval 'sub _PAGE_ACCESSED () {(1<<3);}' unless defined(&_PAGE_ACCESSED);
    eval 'sub _PAGE_MODIFIED () {(1<<4);}' unless defined(&_PAGE_MODIFIED);
    if(defined( &CONFIG_CPU_R3000)) {
	eval 'sub _PAGE_GLOBAL () {(1<<8);}' unless defined(&_PAGE_GLOBAL);
	eval 'sub _PAGE_VALID () {(1<<9);}' unless defined(&_PAGE_VALID);
	eval 'sub _PAGE_SILENT_READ () {(1<<9);}' unless defined(&_PAGE_SILENT_READ);
	eval 'sub _PAGE_DIRTY () {(1<<10);}' unless defined(&_PAGE_DIRTY);
	eval 'sub _PAGE_SILENT_WRITE () {(1<<10);}' unless defined(&_PAGE_SILENT_WRITE);
	eval 'sub _CACHE_UNCACHED () {(1<<11);}' unless defined(&_CACHE_UNCACHED);
	eval 'sub _CACHE_MASK () {(1<<11);}' unless defined(&_CACHE_MASK);
	eval 'sub _CACHE_CACHABLE_NONCOHERENT () {0;}' unless defined(&_CACHE_CACHABLE_NONCOHERENT);
    } else {
	eval 'sub _PAGE_R4KBUG () {(1<<5);}' unless defined(&_PAGE_R4KBUG);
	eval 'sub _PAGE_GLOBAL () {(1<<6);}' unless defined(&_PAGE_GLOBAL);
	eval 'sub _PAGE_VALID () {(1<<7);}' unless defined(&_PAGE_VALID);
	eval 'sub _PAGE_SILENT_READ () {(1<<7);}' unless defined(&_PAGE_SILENT_READ);
	eval 'sub _PAGE_DIRTY () {(1<<8);}' unless defined(&_PAGE_DIRTY);
	eval 'sub _PAGE_SILENT_WRITE () {(1<<8);}' unless defined(&_PAGE_SILENT_WRITE);
	eval 'sub _CACHE_CACHABLE_NO_WA () {(0<<9);}' unless defined(&_CACHE_CACHABLE_NO_WA);
	eval 'sub _CACHE_CACHABLE_WA () {(1<<9);}' unless defined(&_CACHE_CACHABLE_WA);
	eval 'sub _CACHE_UNCACHED () {(2<<9);}' unless defined(&_CACHE_UNCACHED);
	eval 'sub _CACHE_CACHABLE_NONCOHERENT () {(3<<9);}' unless defined(&_CACHE_CACHABLE_NONCOHERENT);
	eval 'sub _CACHE_CACHABLE_CE () {(4<<9);}' unless defined(&_CACHE_CACHABLE_CE);
	eval 'sub _CACHE_CACHABLE_COW () {(5<<9);}' unless defined(&_CACHE_CACHABLE_COW);
	eval 'sub _CACHE_CACHABLE_CUW () {(6<<9);}' unless defined(&_CACHE_CACHABLE_CUW);
	eval 'sub _CACHE_CACHABLE_ACCELERATED () {(7<<9);}' unless defined(&_CACHE_CACHABLE_ACCELERATED);
	eval 'sub _CACHE_MASK () {(7<<9);}' unless defined(&_CACHE_MASK);
    }
    eval 'sub __READABLE () {( &_PAGE_READ |  &_PAGE_SILENT_READ |  &_PAGE_ACCESSED);}' unless defined(&__READABLE);
    eval 'sub __WRITEABLE () {( &_PAGE_WRITE |  &_PAGE_SILENT_WRITE |  &_PAGE_MODIFIED);}' unless defined(&__WRITEABLE);
    eval 'sub _PAGE_CHG_MASK () {( &PAGE_MASK |  &_PAGE_ACCESSED |  &_PAGE_MODIFIED |  &_CACHE_MASK);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_PRESENT |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_NONE);
    eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_PAGE_WRITE |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_SHARED);
    eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_COPY);
    eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_READONLY);
    eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_PRESENT |  &__READABLE |  &__WRITEABLE |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_KERNEL);
    eval 'sub PAGE_USERIO () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_PAGE_WRITE |  &_CACHE_UNCACHED);}' unless defined(&PAGE_USERIO);
    eval 'sub PAGE_KERNEL_UNCACHED () { &__pgprot( &_PAGE_PRESENT |  &__READABLE |  &__WRITEABLE |  &_CACHE_UNCACHED);}' unless defined(&PAGE_KERNEL_UNCACHED);
    eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
    eval 'sub __P001 () { &PAGE_READONLY;}' unless defined(&__P001);
    eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
    eval 'sub __P011 () { &PAGE_COPY;}' unless defined(&__P011);
    eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
    eval 'sub __P101 () { &PAGE_READONLY;}' unless defined(&__P101);
    eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
    eval 'sub __P111 () { &PAGE_COPY;}' unless defined(&__P111);
    eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
    eval 'sub __S001 () { &PAGE_READONLY;}' unless defined(&__S001);
    eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
    eval 'sub __S011 () { &PAGE_SHARED;}' unless defined(&__S011);
    eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
    eval 'sub __S101 () { &PAGE_READONLY;}' unless defined(&__S101);
    eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
    eval 'sub __S111 () { &PAGE_SHARED;}' unless defined(&__S111);
    if(!defined ( &_LANGUAGE_ASSEMBLY)) {
	eval 'sub pte_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pte %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pmd %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    local($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pgd %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
	}' unless defined(&pgd_ERROR);
	eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
	eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
	eval 'sub ZERO_PAGE {
	    local($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page + ((($vaddr)) &  &zero_page_mask))));
	}' unless defined(&ZERO_PAGE);
	eval 'sub BITS_PER_PTR () {(8*$sizeof{\'unsigned long\'});}' unless defined(&BITS_PER_PTR);
	eval 'sub PTR_MASK () {(~($sizeof{ &void}-1));}' unless defined(&PTR_MASK);
	eval 'sub SIZEOF_PTR_LOG2 () {2;}' unless defined(&SIZEOF_PTR_LOG2);
	eval 'sub PAGE_PTR {
	    local($address) = @_;
    	    eval q((($address)>>( &PAGE_SHIFT- &SIZEOF_PTR_LOG2) &PTR_MASK&~ &PAGE_MASK));
	}' unless defined(&PAGE_PTR);
	eval 'sub page_address {
	    local($page) = @_;
    	    eval q((($page)-> &virtual));
	}' unless defined(&page_address);
	eval 'sub pte_page {
	    local($x) = @_;
    	    eval q(( &mem_map+(( &pte_val($x) >>  &PAGE_SHIFT))));
	}' unless defined(&pte_page);
	eval 'sub mk_pte {
	    local($page, $pgprot) = @_;
    	    eval q(({  &pte_t  &__pte;  &pte_val = (($page -  &mem_map) <<  &PAGE_SHIFT) |  &pgprot_val($pgprot);  &__pte; }));
	}' unless defined(&mk_pte);
	eval 'sub page_pte {
	    local($page) = @_;
    	    eval q( &page_pte_prot($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub pgd_offset_k {
	    local($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pgd_index {
	    local($address) = @_;
    	    eval q((($address) >>  &PGDIR_SHIFT));
	}' unless defined(&pgd_index);
	eval 'sub pte_free_kernel {
	    local($pte) = @_;
    	    eval q( &free_pte_fast($pte));
	}' unless defined(&pte_free_kernel);
	eval 'sub pte_free {
	    local($pte) = @_;
    	    eval q( &free_pte_fast($pte));
	}' unless defined(&pte_free);
	eval 'sub pgd_free {
	    local($pgd) = @_;
    	    eval q( &free_pgd_fast($pgd));
	}' unless defined(&pgd_free);
	eval 'sub pgd_alloc () {
	    eval q( &get_pgd_fast());
	}' unless defined(&pgd_alloc);
	eval 'sub SWP_TYPE {
	    local($x) = @_;
    	    eval q(((($x). &val >> 1) & 0x3f));
	}' unless defined(&SWP_TYPE);
	eval 'sub SWP_OFFSET {
	    local($x) = @_;
    	    eval q((($x). &val >> 8));
	}' unless defined(&SWP_OFFSET);
	eval 'sub SWP_ENTRY {
	    local($type,$offset) = @_;
    	    eval q((( &swp_entry_t) { (($type) << 1) | (($offset) << 8) }));
	}' unless defined(&SWP_ENTRY);
	eval 'sub pte_to_swp_entry {
	    local($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
	}' unless defined(&pte_to_swp_entry);
	eval 'sub swp_entry_to_pte {
	    local($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&swp_entry_to_pte);
	eval 'sub module_map () { &vmalloc;}' unless defined(&module_map);
	eval 'sub module_unmap () { &vfree;}' unless defined(&module_unmap);
	eval 'sub PageSkip {
	    local($page) = @_;
    	    eval q((0));
	}' unless defined(&PageSkip);
	eval 'sub kern_addr_valid {
	    local($addr) = @_;
    	    eval q((1));
	}' unless defined(&kern_addr_valid);
    }
    eval 'sub io_remap_page_range () { &remap_page_range;}' unless defined(&io_remap_page_range);
}
1;
