require '_h2ph_pre.ph';

unless(defined(&_FP_W_TYPE_SIZE)) {
    sub _FP_W_TYPE_SIZE () {	32;}
}
unless(defined(&_FP_W_TYPE)) {
    sub _FP_W_TYPE () {	'unsigned long';}
}
unless(defined(&_FP_WS_TYPE)) {
    sub _FP_WS_TYPE () {	'signed long';}
}
unless(defined(&_FP_I_TYPE)) {
    sub _FP_I_TYPE () {	'long';}
}
unless(defined(&_FP_MUL_MEAT_S)) {
    sub _FP_MUL_MEAT_S {
	local($R,$X,$Y) = @_;
	eval q( &_FP_MUL_MEAT_1_wide( &_FP_WFRACBITS_S,$R,$X,$Y, &umul_ppmm));
    }
}
unless(defined(&_FP_MUL_MEAT_D)) {
    sub _FP_MUL_MEAT_D {
	local($R,$X,$Y) = @_;
	eval q( &_FP_MUL_MEAT_2_wide( &_FP_WFRACBITS_D,$R,$X,$Y, &umul_ppmm));
    }
}
unless(defined(&_FP_MUL_MEAT_Q)) {
    sub _FP_MUL_MEAT_Q {
	local($R,$X,$Y) = @_;
	eval q( &_FP_MUL_MEAT_4_wide( &_FP_WFRACBITS_Q,$R,$X,$Y, &umul_ppmm));
    }
}
unless(defined(&_FP_DIV_MEAT_S)) {
    sub _FP_DIV_MEAT_S {
	local($R,$X,$Y) = @_;
	eval q( &_FP_DIV_MEAT_1_udiv_norm( &S,$R,$X,$Y));
    }
}
unless(defined(&_FP_DIV_MEAT_D)) {
    sub _FP_DIV_MEAT_D {
	local($R,$X,$Y) = @_;
	eval q( &_FP_DIV_MEAT_2_udiv( &D,$R,$X,$Y));
    }
}
unless(defined(&_FP_DIV_MEAT_Q)) {
    sub _FP_DIV_MEAT_Q {
	local($R,$X,$Y) = @_;
	eval q( &_FP_DIV_MEAT_4_udiv( &Q,$R,$X,$Y));
    }
}
unless(defined(&_FP_NANFRAC_S)) {
    sub _FP_NANFRAC_S () {	(( &_FP_QNANBIT_S << 1) - 1);}
}
unless(defined(&_FP_NANFRAC_D)) {
    sub _FP_NANFRAC_D () {	(( &_FP_QNANBIT_D << 1) - 1), -1;}
}
unless(defined(&_FP_NANFRAC_Q)) {
    sub _FP_NANFRAC_Q () {	(( &_FP_QNANBIT_Q << 1) - 1), -1, -1, -1;}
}
unless(defined(&_FP_NANSIGN_S)) {
    sub _FP_NANSIGN_S () {	0;}
}
unless(defined(&_FP_NANSIGN_D)) {
    sub _FP_NANSIGN_D () {	0;}
}
unless(defined(&_FP_NANSIGN_Q)) {
    sub _FP_NANSIGN_Q () {	0;}
}
unless(defined(&_FP_KEEPNANFRACP)) {
    sub _FP_KEEPNANFRACP () {	1;}
}
unless(defined(&_FP_CHOOSENAN)) {
    sub _FP_CHOOSENAN {
	local($fs, $wc, $R, $X, $Y, $OP) = @_;
	eval q( &do {  &if (( &_FP_FRAC_HIGH_RAW_$fs($X) |  &_FP_FRAC_HIGH_RAW_$fs($Y)) &  &_FP_QNANBIT_$fs) { $R &_s =  &_FP_NANSIGN_$fs;  &_FP_FRAC_SET_$wc($R, &_FP_NANFRAC_$fs); }  &else { $R &_s = $X &_s;  &_FP_FRAC_COPY_$wc($R,$X); } $R &_c =  &FP_CLS_NAN; }  &while (0));
    }
}
unless(defined(&FP_EX_INVALID)) {
    sub FP_EX_INVALID () {	(1<< 4);}
}
unless(defined(&FP_EX_DIVZERO)) {
    sub FP_EX_DIVZERO () {	(1<< 3);}
}
unless(defined(&FP_EX_OVERFLOW)) {
    sub FP_EX_OVERFLOW () {	(1<< 2);}
}
unless(defined(&FP_EX_UNDERFLOW)) {
    sub FP_EX_UNDERFLOW () {	(1<< 1);}
}
unless(defined(&FP_EX_INEXACT)) {
    sub FP_EX_INEXACT () {	(1<< 0);}
}
1;
