require '_h2ph_pre.ph';

unless(defined(&_ASM_SYSTEM_H)) {
    eval 'sub _ASM_SYSTEM_H () {1;}' unless defined(&_ASM_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/sgidefs.ph';
    require 'asm/ptrace.ph';
    require 'linux/kernel.ph';
    eval 'sub __save_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__( \\".set\\\\tpush\\\\n\\\\t\\" \\".set\\\\treorder\\\\n\\\\t\\" \\"mfc0\\\\t%0,$12\\\\n\\\\t\\" \\".set\\\\tpop\\\\n\\\\t\\" : \\"=r\\" ($x)));
    }' unless defined(&__save_flags);
    eval 'sub __save_and_cli {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__( \\".set\\\\tpush\\\\n\\\\t\\" \\".set\\\\treorder\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\\\t\\" \\"mfc0\\\\t%0,$12\\\\n\\\\t\\" \\"ori\\\\t$1,%0,1\\\\n\\\\t\\" \\"xori\\\\t$1,1\\\\n\\\\t\\" \\".set\\\\tnoreorder\\\\n\\\\t\\" \\"mtc0\\\\t$1,$12\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\".set\\\\tpop\\\\n\\\\t\\" : \\"=r\\" ($x) : : \\"$1\\", \\"memory\\"));
    }' unless defined(&__save_and_cli);
    eval 'sub sti () {
        eval q( &__sti());
    }' unless defined(&sti);
    eval 'sub cli () {
        eval q( &__cli());
    }' unless defined(&cli);
    eval 'sub save_flags {
        local($x) = @_;
	    eval q( &__save_flags($x));
    }' unless defined(&save_flags);
    eval 'sub save_and_cli {
        local($x) = @_;
	    eval q( &__save_and_cli($x));
    }' unless defined(&save_and_cli);
    eval 'sub restore_flags {
        local($x) = @_;
	    eval q( &__restore_flags($x));
    }' unless defined(&restore_flags);
    eval 'sub local_irq_save {
        local($x) = @_;
	    eval q( &__save_and_cli($x););
    }' unless defined(&local_irq_save);
    eval 'sub local_irq_restore {
        local($x) = @_;
	    eval q( &__restore_flags($x););
    }' unless defined(&local_irq_restore);
    eval 'sub local_irq_disable () {
        eval q( &__cli(););
    }' unless defined(&local_irq_disable);
    eval 'sub local_irq_enable () {
        eval q( &__sti(););
    }' unless defined(&local_irq_enable);
    if(defined(&CONFIG_CPU_HAS_WB)) {
	require 'asm/wbflush.ph';
	eval 'sub rmb () {
	    eval q();
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &wbflush());
	}' unless defined(&wmb);
	eval 'sub mb () {
	    eval q( &wbflush());
	}' unless defined(&mb);
    } else {
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__( \\"# prevent instructions being moved around\\\\n\\\\t\\" \\".set\\\\tnoreorder\\\\n\\\\t\\" \\"# 8 nops to fool the R4400 pipeline\\\\n\\\\t\\" \\"nop;nop;nop;nop;nop;nop;nop;nop\\\\n\\\\t\\" \\".set\\\\treorder\\" : : : \\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
    } else {
	eval 'sub smp_mb () {
	    eval q( &barrier());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &barrier());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &barrier());
	}' unless defined(&smp_wmb);
    }
    eval 'sub set_mb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &mb(); }  &while (0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        local($var, $value) = @_;
	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
    }' unless defined(&set_wmb);
    if(!defined ( &_LANGUAGE_ASSEMBLY)) {
    }
    eval 'sub prepare_to_switch () {
        eval q( &do { }  &while(0));
    }' unless defined(&prepare_to_switch);
    eval 'sub switch_to {
        local($prev,$next,$last) = @_;
	    eval q( &do { ($last) =  &resume($prev, $next); }  &while(0));
    }' unless defined(&switch_to);
    if(defined( &CONFIG_CPU_HAS_LLSC)) {
    } else {
    }
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    if(defined( &__mips64)) {
    }
    eval 'sub die {
        local($msg, $regs) = @_;
	    eval q( &__die($msg, $regs,  &__FILE__ \\":\\" &__FUNCTION__,  &__LINE__));
    }' unless defined(&die);
    eval 'sub die_if_kernel {
        local($msg, $regs) = @_;
	    eval q( &__die_if_kernel($msg, $regs,  &__FILE__ \\":\\" &__FUNCTION__,  &__LINE__));
    }' unless defined(&die_if_kernel);
}
1;
